#coding:utf-8
from model._db import celery
from misc.config import HOST
from types import FunctionType

def call(func, args):
    if type(func) is FunctionType:
        args = args[:func.func_code.co_argcount]
    func(*args)

class Signal(object):
    def __init__(self, name):
        self._sync = []
        self._async = []
        @celery.task(name=name)
        def _(*args):
            for func in self._async:
                call(func,args)

        self._delay = 0 
        self.delay = _.delay  

    def send(self, *args):
        for func in self._sync:
            call(func,args)
        if self._delay: 
            self.delay(*args)

    def __call__(self, func):
        self._sync.append(func)
        return func

    def delay(self, func):
        self._async.append(func)
        self._delay = len(self._async) 
        return func


class _(object):
    def __getattr__(self, name):
        d = self.__dict__
        if name not in d:
            d[name] = Signal("%s.%s"%(HOST,name))
        return d[name]
        

SIGNAL = _()

if __name__ == "__main__":


    @SIGNAL.follow_new
    def _follow_new(a,b):
        print a,b 
   
    @SIGNAL.follow_new.delay
    def _follow_new(a, b):
        print a,b
    SIGNAL.follow_new.send(1 , 3)

